<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
try
{
	$licegi = Model_esia::getLicenceInformation($dbconnection,'LICENCE_EGIDE');
}
catch (Exception $e)
{
	$smarty->assign('need_licence','EGIDE');
	$smarty->display('no_licence.html');
	exit(0);
}
include_once $path.'/Model_adm.php';
//on récupère le nom du serveur
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
$webp_name = 'WEBP_EGIDESCAN';
include_once $path.'/inc/common_node_control.php';

// echo $node->getName();
$smarty->assign('node_id',$node->getId());

// echo 'id'.$node->getId();;



$params = array('filters'=>$_REQUEST['filters'],
	'order'=> $_REQUEST['cols'],
	'size'=>50,
	'paging'=>0);
if (isset($_GET['page']) && ! empty($_GET['page']))
{
	$params['paging'] = $_GET['page'];
}
if (isset($_GET['size']) && ! empty($_GET['size']))
{
	if ($_GET['size'] == 'all')
	{
		$_GET['size'] = 100;
	}
	$params['size'] = $_GET['size'];
}

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_EGIDESCAN');
$plugin_url = $arr[0]['apache_path'];

$smarty->assign('plugin_url',$plugin_url);

include_once $path.'/'.$plugin_url.'/model_ts_egidescan.php';
include_once $path.'/'.$plugin_url.'/common_egidescan.php';

include_once $path.'/'.$plugin_url.'/model_egidescan.php';

$plugin_template_path = $path.'/'.$plugin_url."/templates";
$smarty->assign('plugin_template_path',$plugin_template_path);

$lang_abre =LANG;
if($user->getLang()!="")
{
	//configuration de la langue de l'application
	$lang_abre = $user->getLang();
}


$severity_count = array ('LOW'=>0,'MEDIUM'=>0,'HIGH'=>0,'CRITICAL'=>0);

$listcve = Model_egidescan::getCVEByScoring($dbconnection,$user->getId(),$node->getId());
$arr=array();
foreach($listcve as $cve)
{
	//chargement Donuts
	if(!empty($cve['complexity']))
	{
		$severity_count[$cve['complexity']]++;
	}
}

$smarty->assign('Severity_count',$severity_count);


$showed_ifaces = showIfaces($dbconnection,NULL,$user->getID(),$node->getId());
$smarty->assign('ifaces_list',$showed_ifaces);

$ifaces_type = Model_egidescan::getEgideIfacesType($dbconnection);
$smarty->assign('ifaces_type', $ifaces_type);

$smarty->assign('treeview_type','box');

include_once $path.'/inc/egide_utils_libs.php';
$all_scores = Model_egidescan::getNumberGlobalByScoring($dbconnection,$user->getId(),$node->getId());
$chart_formatted = transformScoresInChartColumn($all_scores);
$smarty->assign('var_chart_culumn_x',$chart_formatted['x']);
$smarty->assign('var_chart_culumn_y',$chart_formatted['y']);

$smarty->display($path.'/'.$plugin_url.'templates/adv_tab_egidescan.html');
?>
