<?php
function getCSSClassByscore($score_value)
{
	$colors = array("color0-1Score",
					"color1-2Score",
					"color2-3Score",
					"color3-4Score",
					"color4-5Score",
					"color5-6Score",
					"color6-7Score",
					"color7-8Score",
					"color8-9Score",
					"color9-10Score",
					"color9-10Score"
	);
	$default_css = "color-NotExist-Score";
	$score_value = floor($score_value); //On arrondi en dessous
	if(isset($colors[$score_value]))
	{
		return $colors[$score_value];
	}
	else
	{
		return $default_css;
	}
}

function devicesOnly($treeview_nodelist)
{
	$tmp = array();
	if( is_array($treeview_nodelist) )
	{
		foreach($treeview_nodelist as $row)
		{
			$tmp[$row['eg_device_id']] = $row['eg_device_id'];
		}
	}
	return array_values($tmp);
}

function getDevicesOfAgentOrGroup($dbconnection,$user,$treeview_type,$treeview_nodeid)
{
	if( $treeview_type == 'root' )
	{
		$treeview_nodelist = Model_egidescan::getDevicesOfAgentGroup($dbconnection,NULL,$user->getId());
	}
	elseif($treeview_type == 'group')
	{
		$treeview_nodelist = Model_egidescan::getDevicesOfAgentGroup($dbconnection,$treeview_nodeid,$user->getId());
	}
	elseif($treeview_type == 'box')
	{
		$treeview_nodelist = Model_egidescan::getDevicesOfAgent($dbconnection,$treeview_nodeid,$user->getId());
	}
	elseif($treeview_type == 'nodeonly')
	{
		return array($treeview_nodeid);
	}
	$treeview_nodelist = devicesOnly($treeview_nodelist);
	return $treeview_nodelist;
}

function getServicesDevices($dbconnection)
{
	$devices_table = Model_egidescan::getDevices($dbconnection);
	$device_id =array();
	$index_device_id = 0 ;
	for($i=0; $i<count($devices_table);$i++)
	{
		if(!in_array($devices_table[$i]['eg_device_id'], $device_id))
		{
			$device_id[$index_device_id] = $devices_table[$i]['eg_device_id'] ;
			$index_device_id ++ ;
		}
	}
	$services_device = array() ; $services_device_index = 0 ;
	$services_devices = array();
	for($j=0; $j<count($device_id);$j++)
	{
		$services_device = array() ; $services_device_index = 0 ;
		for($i=0; $i<count($devices_table);$i++)
		{
			if($devices_table[$i]['eg_device_id']==$device_id[$j])
			{
				$services_device[$services_device_index] = $devices_table[$i]['eg_service_id'] ;
				$services_device_index ++ ;
			}
		}
		for($k=0; $k<count($services_device);$k++)
		{
			// recupererer les id cve
			$services_devices[$device_id[$j]] = $services_device ;
		}
	}
	return $services_devices;
}

function showIfaces($dbconnection,$agent_id=NULL,$user=NULL,$nodeid=NULL)
{
	$agent_ifaces = Model_egidescan::getConfiguratedEgideBoxIfaces($dbconnection,$agent_id);
	$showed_ifaces = array();

	//Pour le tri des groupes
	$ifaces_type = array();
	$ifaces_id_list = array();
	foreach($agent_ifaces as $row)
	{
		$ifaces_type[$row['type_factor']][$row['type_name']] = $row;
		$ifaces_id_list[] = $row['id'];
	}


	krsort($ifaces_type);
	foreach($ifaces_type as $key => $row)
	{
		ksort($ifaces_type[$key]);
	}

	foreach($ifaces_type as $factor)
	{
		foreach($factor as $name => $row)
		{
			$showed_ifaces[$name] = array();
		}
	}

	//Récupération et analyse des vulnérability
	$ifaces_score = array();

	if( $nodeid == NULL )
	{
		$stats = Model_egidescan::getVulnerabilityStats($dbconnection,$ifaces_id_list);

		//On initialise à 0 les interfaces
		foreach($ifaces_id_list as $iface_id)
		{
			$ifaces_score[$iface_id]['max_score'] = 0;
			$ifaces_score[$iface_id]['sum_score'] = 0;
			$ifaces_score[$iface_id]['total_vul'] = 0;
		}
	}
	else
	{
		$stats = Model_egidescan::getNodesStats($dbconnection,$user,$ifaceList,NULL,FALSE,$nodeid);

		//On initialise à 0 les interfaces
		foreach($stats as $stat)
		{
			if( !isset($ifaces_score[$stat['iface_id']]))
			{
				$ifaces_score[$stat['iface_id']]['max_score'] = 0;
				$ifaces_score[$stat['iface_id']]['sum_score'] = 0;
				$ifaces_score[$stat['iface_id']]['total_vul'] = 0;
			}
		}

		//On supprime les interfaces non désirées
		$new_agent_ifaces = array();
		foreach($ifaces_score as $key => $values)
		{
			foreach($agent_ifaces as $iface)
			{
				if( $iface['id'] == $key )
				{
					$new_agent_ifaces[] = $iface;
				}
			}
		}
		$agent_ifaces = $new_agent_ifaces;
	}

	foreach($stats as $row)
	{
		$ifaces_score[$row['iface_id']]['total_vul'] += $row['total_vul'];
		$ifaces_score[$row['iface_id']]['averageScoring'] += $row['averageVulnerabilityScoring'];
	}

	foreach($agent_ifaces as $key => $agent_iface)
	{
		$retRow = array();

		$iface_stats = $ifaces_score[$agent_iface['id']];

		if( $iface_stats['total_vul'] > 0 )
		{
			$calculed_score =  $iface_stats['averageScoring'];
		}
		else
		{
			$calculed_score = 0;
		}

		$factor = $agent_iface['type_factor'];

		$retRow['label'] = $agent_iface['label'];
		$retRow['value'] = $calculed_score;
		$retRow['color'] = Model_egidescan::getScoreHtmlColor($calculed_score);

		$group_name =  $agent_iface['type_name'];

		if( !isset($showed_ifaces[$group_name]['label']))
		{
			$showed_ifaces[$group_name]['label'] = $group_name;
			$showed_ifaces[$group_name]['factor'] = $factor;
			$showed_ifaces[$group_name]['color'] =  $agent_iface['type_color'];
			$showed_ifaces[$group_name]['ifaces'] = array();
			$factor_list[] = $factor;
		}
		$showed_ifaces[$group_name]['ifaces'][] = $retRow;
	}
	return $showed_ifaces ;
}

function assignDonutAndVulnerabilities($smarty,$vulnerability_nodes,$lang_fr_CVE_severity,$BlockOrWidget=FALSE)
{
	$vulnerability_nodes_updated = array() ; $vulnerability_nodes_index =0 ;
	$all_scores = array();
	$Severity_count =array(
		'LOW' => 0,
		'MEDIUM' => 0,
		'CRITICAL' => 0,
		'HIGH' => 0
	);
	foreach ($vulnerability_nodes as $value)
	{
		// 	$vulnerability_nodes_updated[$vulnerability_nodes_index] = $value ;
		$all_scores[] = $value['cve_score'] ;
		if($value['cve_cmplx'] == 'LOW')
		{
			$Severity_count['LOW'] ++ ;
		}
		elseif($value['cve_cmplx'] == 'MEDIUM')
		{
			$Severity_count['MEDIUM'] ++ ;
		}
		elseif($value['cve_cmplx'] == 'CRITICAL')
		{
			$Severity_count['CRITICAL'] ++ ;
		}
		elseif($value['cve_cmplx'] == 'HIGH')
		{
			$Severity_count['HIGH'] ++ ;
		}
		else
		{

		}
		$vulnerability_nodes_updated[$vulnerability_nodes_index] = array(
			'cve' => $value['cve'],
			'match' => $value['match'],
			'cve_descr' => $value['cve_descr'],
			'cve_score' => $value['cve_score'],
			'cve_severt' => $lang_fr_CVE_severity[$value['cve_severt']],
			'cve_cmplx' => $lang_fr_CVE_severity[$value['cve_cmplx']],
		);
		$vulnerability_nodes_index ++ ;
	}

	$smarty->assign('Severity_count',$Severity_count);
	$smarty->assign('vulnerability_nodes_updated', $vulnerability_nodes_updated);

	if($BlockOrWidget)
	{
		return $all_scores ;
	}
}

?>
