<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
// $webp_name doit être identique au nom de la base de données !!!
$webp_name='egidescan';
//$webp_model='model_'.$webp_name.'.php';
//Inclusion des librairie
include_once $path.'/common.php';
include_once $path.'/Model_esia.php';
include_once $path.'/Model_adm.php';
try
{
	$licegi = Model_esia::getLicenceInformation($dbconnection,'LICENCE_EGIDE');
}
catch (Exception $e)
{
	$smarty->assign('need_licence','EGIDE');
	$smarty->display('no_licence.html');
	exit(0);
}
$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_EGIDESCAN');
$plugin_url = $arr[0]['apache_path'];
$index_page = $arr[0]['index_page'];
$smarty->assign('plugin_url',$plugin_url);
include_once $path.$plugin_url.'/model_egidescan.php';
include_once $path.$plugin_url.'/common_egidescan.php';

include_once $path.'/'.$plugin_url.'/model_ts_egidescan.php';

$template_path = $plugin_url.'/templates/';

$plugin_template_path = $path.$plugin_url."/templates";
$smarty->assign('plugin_template_path',$plugin_template_path);

/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
// include_once $path.'/inc/common_node_control.php';

//Variable passé en paramètre
$tab='';
if(isset($_GET['tab'])&& !empty($_GET['tab']))
{
	$tab=$_GET['tab'];
}
$action='';
if(isset($_GET['action'])&& !empty($_GET['action']))
{
	$action=$_GET['action'];
}
$smarty->assign('tab', $tab);


$navbar->addElement($lang['WEBP_EGIDESCAN'], $plugin_url . $index_page);

session_write_close();

if(!isset($_REQUEST['tab']))
{
	if( isset($_REQUEST['group']))
	{
		$devicegroup=$_REQUEST['group'];
		addNavNodeGroups($dbconnection,$navbar,$plugin_url . $index_page. '?group=:id',$devicegroup);
		$tgroup = Model_adm::getGroupDeviceIn($dbconnection,$devicegroup);
		$navbar->addElement($tgroup[0]['name'] ,$plugin_url . $index_page. "?group=$devicegroup");

		$smarty->assign('treeview','group');
		$smarty->assign('nodeid',$devicegroup);

		unset($tgroup[0]['child']);
		$page_header_bar['type'] = 'group';
		$page_header_bar['value'] = $tgroup[0];
		if( empty($page_header_bar['value']['description']))
		{
			$page_header_bar['value']['description'] = $lang['EGIDE_NO_DESCRIPTION'];
		}
		$page_header_bar['devices'] = count(devicesOnly(Model_egidescan::getDevicesOfAgentGroup($dbconnection,$devicegroup,$user->getId())));
		$page_header_bar['boxes'] = count(Model_egidescan::getAgentsOfGroup($dbconnection,$devicegroup,$user->getId()));
		$page_header_bar['page_url'] = '/node_index.php?nodegroup=' . $devicegroup;
	}
	elseif( isset($_REQUEST['box']))
	{
		$boxid = $_REQUEST['box'];
		$box = Model_esia::InstanceNode($dbconnection,$boxid);
		$parentid = $box->getGroupId();

		addNavNodeGroups($dbconnection,$navbar,$plugin_url . $index_page. '?group=:id',$parentid);
		$tgroup = Model_adm::getGroupDeviceIn($dbconnection,$parentid);
		$navbar->addElement($tgroup[0]['name'] ,$plugin_url . $index_page. "?group=$parentid");
		$navbar->addElement($box->getName() ,$plugin_url . $index_page. "?box=$boxid");

		$smarty->assign('treeview','box');
		$smarty->assign('nodeid',$boxid);

		$page_header_bar['type'] = 'box';
		$page_header_bar['value'] = array('name'=>$box->getName(),'description'=>$box->getDescription(),'address'=>$box->getIPAddress());
		if( empty($page_header_bar['value']['description']))
		{
			$page_header_bar['value']['description'] = $lang['EGIDE_NO_DESCRIPTION'];
		}
		$page_header_bar['devices'] = count(devicesOnly(Model_egidescan::getDevicesOfAgent($dbconnection,$boxid,$user->getId())));
		$page_header_bar['vulnerabilities'] = count(Model_egidescan::getCVEVulDetect($dbconnection,$boxid ));
		$page_header_bar['boxes'] = count(Model_egidescan::getAgentsOfGroup($dbconnection,NULL,$user->getId()));
		$page_header_bar['page_url'] = '/plugin/gesa/gesa_control.php?nodeid=' . $boxid;

		$box_gesa = Model_gesa::getInstanceGESA($dbconnection, $boxid);
		$page_header_bar['gesa']['sn'] = $box_gesa->getSerialNumber();

		// Get box state event class for color & text
		$BoxStates = Model_esia::countNodeState($dbconnection, $boxid);
		$page_header_bar['gesa']['state'] = $lang['EGIDE_BOX_SHORT'] . ' ';
		if($BoxStates['critical'] > 0)
		{
			$page_header_bar['gesa']['state'] .= $lang['EGIDE_BOX_UNREACHEABLE'];
			$page_header_bar['gesa']['stateClass'] = 'EventCritical';
		}
		elseif($BoxStates['warning'] > 0)
		{
			$page_header_bar['gesa']['state'] .= $lang['ALERTS'];
			$page_header_bar['gesa']['stateClass'] = 'EventWarning';
		}
		elseif($BoxStates['unknown'] > 0)
		{
			$page_header_bar['gesa']['state'] .= $lang['EGIDE_BOX_UNREACHEABLE'];
			$page_header_bar['gesa']['stateClass'] = 'EventUnknown';
		}
		else
		{
			// Get scans to check box next states
			$scan_list = Model_egidescan::getAgentScanList($dbconnection, $boxid);
			$scan_status = '';

			if(!empty($scan_list))
			{
				$priorities = array(
					Model_egidescan::ERROR_TASK=>0,
					Model_egidescan::PENDING_TASK=>1,
					Model_egidescan::NEW_TASK=>2,
					Model_egidescan::PROCESSING_TASK=>3,
					Model_egidescan::TERMINATED_TASK=>4,
					'Unknown'=>5
				);
				$scan_status = 'Unknown';
				foreach($scan_list as $scan)
				{
					if($priorities[$scan_status] > $priorities[$scan['state']])
					{
						$scan_status = $scan['state'];
					}
				}
			}

			if($scan_status == '' || $scan_status == 'terminated')
			{
				$page_header_bar['gesa']['state'] .= $lang['EGIDE_BOX_REACHEABLE'];
				$page_header_bar['gesa']['stateClass'] = 'EventOK';
			}
			else
			{
				$statusLangKey = 'EGIDE_SCAN_' . strtoupper($scan_status) . '_TASK';
				$page_header_bar['gesa']['state'] = $lang['EGIDE_SCAN'] . ' ' . strtolower($lang[$statusLangKey]);
				if($scan_status == 'error')
				{
					$page_header_bar['gesa']['stateClass'] = 'EventCritical';
				}
				else
				{
					$page_header_bar['gesa']['stateClass'] = 'EventPending';
				}
			}
		}
	}
	else
	{
		$smarty->assign('treeview','root');
		$smarty->assign('nodeid','root');

		$page_header_bar['type'] = 'group';
		$page_header_bar['value']['name'] = $lang['GROUPNODE_ROOT'];
		$page_header_bar['value']['description'] = $lang['EGIDE_NO_ROOT_DESCRIPTION'];
		$page_header_bar['devices'] = count(devicesOnly(Model_egidescan::getDevicesOfAgentGroup($dbconnection,NULL,$user->getId())));
		$page_header_bar['boxes'] = count(Model_egidescan::getAgentsOfGroup($dbconnection,NULL,$user->getId()));
		$page_header_bar['page_url'] = '/node_index.php';
	}
	$smarty->assign('page_header_bar',$page_header_bar);
}
else
{
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%";

$smarty->assign('treeview',$_REQUEST['treeview']);
$smarty->assign('nodeid',$_REQUEST['nodeid']);

if(isset($_REQUEST['treeview']))
{
	$treeview_type = $_REQUEST['treeview'];
	$treeview_nodeid = $_REQUEST['nodeid'];
	$treeview_nodelist = getDevicesOfAgentOrGroup($dbconnection,$user,$treeview_type,$treeview_nodeid);
	$treeview_ifaceslist = Model_egidescan::getIFacesList($dbconnection,$user->getId(),$treeview_type,$treeview_nodeid);
}

try
{
	if($tab == 'node' || $tab == 'home' )
	{
		$nodeInfo = array();
		if(!empty($treeview_ifaceslist))
		{
			if( $tab == 'node' )
			{
				$nodeInfo = Model_egidescan::getNodesStats($dbconnection,$user->getId(),$treeview_ifaceslist,NULL,TRUE);
			}
			else
			{
				$nodeInfo = Model_egidescan::getNodesStats($dbconnection,$user->getId(),$treeview_ifaceslist,10,FALSE);
			}
		}

		$ret = array();
		foreach($nodeInfo as $node)
		{
			$ret[]=array('id' => $node['id'],
				'name' => $node['name'],
				'iface' => $node['iface_label'],
				'iface_color' => $node['iface_color'],
				'type' => $node['type'],
				'address' => $node['ip'],
				'description' => $node['description'],
				'scoring' => $node['averageVulnerabilityScoring'],
				'vul_number' => $node['numberVulnerability'],
				'score_max' => $node['maxVulnerabilityScoring'],
				'score_max_color' => Model_egidescan::getScoreHtmlColor( $node['maxVulnerabilityScoring']),
				'css'=> getCSSClassByscore($node['averageVulnerabilityScoring']),
				'css_max'=> getCSSClassByscore($node['maxVulnerabilityScoring'])
			);
		}
		$smarty->assign('nodeMaxScoring',$ret);

		$smarty->assign('treeview_type',$treeview_type);
		if( $treeview_type == 'box')
		{
			$agent_id = $treeview_nodeid;

			//$lang_fr_CVE_severity = $lang['EGIDE_CVE_SEVERITY_TYPE'];
			$cveDetected = Model_egidescan::getCVEVulDetect($dbconnection,$agent_id);

			$showed_ifaces = showIfaces($dbconnection,$agent_id,$user->getId()) ;

			$smarty->assign('ifaces_list',$showed_ifaces);

			// Iface types weight
			$ifaces_type = Model_egidescan::getEgideIfacesType($dbconnection);
			$smarty->assign('ifaces_type', $ifaces_type);
		}
		else
		{
			$group_id = NULL;
			if( $treeview_type == 'group' )
			{
				$group_id = $treeview_nodeid;
			}

			$listBoxes = Model_egidescan::getAgentsOfGroup($dbconnection,$group_id,$user->getId());

			//On ne récupére pas une seconde fois les donnés si la boxe est déjà ajoutée
			$tmp = array();
			foreach($listBoxes as $idx => $box)
			{
				if( !isset($tmp[$box['id']]))
				{
					$tmp[$box['id']] = $box;
				}
			}
			$listBoxes = $tmp;

			$nb_boxes = count($listBoxes);

			$header_show_all = FALSE;
			$header_stats = FALSE;
			if( $nb_boxes <= 8 )
			{
				$header_show_all = TRUE;
			}
			$smarty->assign('header_show_all',$header_show_all);

			if( $nb_boxes <= 12 )
			{
				$smarty->assign('header_show_min',FALSE);
			}
			elseif($nb_boxes <= 26)
			{
				$smarty->assign('header_show_min',TRUE);
			}
			else
			{
				$header_stats = TRUE;
			}
			$smarty->assign('header_show_stats',$header_stats);

			foreach($listBoxes as $idx => $box)
			{
				$scan_list = Model_egidescan::getAgentScanList($dbconnection, $box['id']);
				$scan_status = NULL;

				$priorities = array(
					Model_egidescan::ERROR_TASK=>0,
					Model_egidescan::PENDING_TASK=>1,
					Model_egidescan::NEW_TASK=>2,
					Model_egidescan::PROCESSING_TASK=>3,
					Model_egidescan::TERMINATED_TASK=>4,
					'None'=>5
				);

				if( !empty($scan_list))
				{
					$scan_status = 'None';
					foreach($scan_list as $scan)
					{
						if( $priorities[$scan_status] > $priorities[$scan['state']] )
						{
							$scan_status = $scan['state'];
						}
					}
				}

				$tmp[$box['id']] = $box;
				$tmp[$box['id']]['box_state'] =  Model_esia::countNodeState($dbconnection, $box['id']);
				$tmp[$box['id']]['scan_state'] = $scan_status;
				if( $header_show_all )
				{
					$vulnerabilities = count(Model_egidescan::getCVEVulDetect($dbconnection,$box['id']));
					$nodes = count(Model_egidescan::getDevicesOfAgent($dbconnection,$box['id']));

					$tmp[$box['id']]['nodes'] = $nodes;
					$tmp[$box['id']]['vulnerabilities'] = $vulnerabilities;
				}
			}

			$listBoxes = $tmp;

			if( $header_stats )
			{
				$stats = array();
				$stats['unity']['total'] = 0;
				$stats['unity']['none'] = 0;
				$stats['unity']['pending'] = 0;
				$stats['unity']['ok'] = 0;
				$stats['unity']['warning'] = 0;
				$stats['unity']['critical'] = 0;
				$stats['unity']['unknown'] = 0;
				$stats['unity']['maintenance'] = 0;
				$stats['unity']['acquitte'] = 0;

				$stats['scan']['total'] = 0;
				$stats['scan']['none'] = 0;
				$stats['scan']['error'] = 0;
				$stats['scan']['terminated'] = 0;
				$stats['scan']['new'] = 0;
				$stats['scan']['pending'] = 0;
				$stats['scan']['processing'] = 0;


				foreach($listBoxes as $row)
				{
					$unity_state = getNodeMostCriticalState($row['box_state']);
					if( !isset($stats['unity'][$unity_state]))
					{
						$stats['unity'][$unity_state] = 0;
					}
					$stats['unity'][$unity_state]++;
					$stats['unity']['total']++;

					if( !isset($stats['scan'][$row['scan_state']]))
					{
						$stats['scan'][$row['scan_state']] = 0;
					}
					$stats['scan'][$row['scan_state']]++;
					$stats['scan']['total']++;
				}
				$smarty->assign('boxesStats',$stats);
			}
			else
			{
				$smarty->assign('listBoxes',$listBoxes);
			}
		}
	}

	if($tab == 'home' )
	{

		$listcve = array();
			if(!empty($treeview_nodelist)) //Pour certains des noeuds Egide (noeuds de la treeview/branche selectionnée)
			{
				$listcve = Model_egidescan::getCVEByScoring($dbconnection,$user->getId(),$treeview_nodelist,10);
			}
			else //On prends tours les noeuds (racine)
			{
				$listcve = Model_egidescan::getCVEByScoring($dbconnection,$user->getId(),$treeview_nodelist,10);
			}
					$arr=array();
					foreach($listcve as $cve)
					{
						$vl_id = Model_egidescan::getCVE_Id($dbconnection,$cve['id']);
						$vl_services = Model_egidescan::getDetectCVEservice($dbconnection,$vl_id);
						$service_tab= array() ;
						foreach($vl_services as $serv)
						{
							$nameAndPort_table = Model_egidescan::getServices_infos($dbconnection,$serv['detect_eg_service_id']);
							$service_tab[] = $nameAndPort_table['srvc_name'] ;
						}
						$service_tab = array_unique($service_tab);
						$service_list = '';
						foreach($service_tab as $serv)
						{
							$service_list = $service_list.', '.$serv;
						}

						$service_list = ltrim($service_list,",") ;
						$l_complexity = $cve['complexity'];
						if(array_key_exists('EGIDE_CVE_SEVERITY_TYPE_'.$l_complexity,$lang))
						{
							$l_complexity =$lang['EGIDE_CVE_SEVERITY_TYPE_'.$l_complexity];
						}
						$l_severity= $cve['severity'];
						if(array_key_exists('EGIDE_CVE_SEVERITY_TYPE_'.$l_severity,$lang))
						{
							$l_severity =$lang['EGIDE_CVE_SEVERITY_TYPE_'.$l_severity];
						}
						$arr[]=array('id' => $cve['id'],
							'description' => $cve['description'],
							'state' => $cve['state'],
							'state_str' => $lang['EGIDE_VULNERABILITY_TABLE_'.$cve['state']],
							'scoring' => $cve['scoring'],
							'severity' => $l_severity,
							'complexity' => $l_complexity,
							'number' => $cve['number'],
							'service' => $service_list,
							'css'=> getCSSClassByscore($cve['scoring'])
						);
					}
					$smarty->assign('vulnerability_array_top10',$arr);


			$all_scores = array();
			if(!empty($treeview_nodelist)) //Pour certains des noeuds Egide (noeuds de la treeview/branche selectionnée)
			{
					$all_scores = Model_egidescan::getNumberGlobalByScoring($dbconnection,$user->getId(),$treeview_nodelist);
			}
			else //On prends tours les noeuds (racine)
			{
					$all_scores = Model_egidescan::getNumberGlobalByScoring($dbconnection,$user->getId());
			}
			$classed_severity = array();
			for($i=0;$i<10;$i++)
			{
				$classed_severity[$i]=0;
			}
			foreach($all_scores as $value)
			{
							$domain = $value['domain'];
				if($domain==10)
				{
						$classed_severity[9] = $classed_severity[9] +  $value['number'];
				}
							else
							{
					$classed_severity[$domain] = $classed_severity[$domain] +  $value['number'];
							}
			}
			array_unshift($classed_severity, 'severity');

			$severity_class = array();
			for($i=0;$i<10;$i++)
			{
				$j = $i+1 ;
				$severity_class[$i]="$i - $j";
			}
			// array_unshift($severity_class, 'x');

			$smarty->assign('var_chart_culumn_x',$severity_class);
			$smarty->assign('var_chart_culumn_y',$classed_severity);
	}
	if($tab == 'scanner')
	{
		$agent_list = array();
		if( $treeview_type == 'box' )
		{
			$agent_list[] = array('id'=>$treeview_nodeid,'name'=>NULL); //id nécessaire, name non utilisé
		}

		elseif( $treeview_type == 'group' )
		{
			$agent_list =  Model_egidescan::getAgentsOfGroup($dbconnection,$user->getId(),$treeview_nodeid);
		}
		elseif( $treeview_type == 'root' )
		{
			$agent_list = Model_egidescan::getEgideBoxList($dbconnection,$user->getId());
		}

		if( count($agent_list) == 1 )
		{

			$smarty->assign('box_id',$agent_list[0]['id']);
		}

		//Récupération des données
		$list_agent_id = array();
		foreach($agent_list as $agent)
		{
			$list_agent_id[] = $agent['id'];
		}
		$scan_list = Model_egidescan::getAgentScanList($dbconnection, $list_agent_id);
		$scanner_history_array = Model_egidescan::getVulnerability_scanner_history($dbconnection,$list_agent_id,100);

		// Traitement des données récupérées
		foreach($scan_list as $key => $scan)
		{
			$groupsName = array();
			if(isset($scan['options']['group_list']))
			{
				foreach($scan['options']['group_list'] as $groupId)
				{
					$group = Model_esia::getGroupDeviceIn($dbconnection, $groupId);
					$group = array_shift($group);
					$groupsName[] = $group['name'];
				}
			}
			$scan_list[$key]['groups'] = implode(', ', $groupsName);
		}

		$smarty->assign('scan_list',$scan_list);

		$ret = array();
		foreach($scanner_history_array as $row)
		{
			$message = json_decode($row['result'],true);
			if($row['scan_state'] == 'error')
			{
				$message = $message['message'];
			}
			elseif($row['scan_state'] == 'terminated')
			{
				$message = $message['result'];
				if(preg_match('/summary=(.*)\>/',$message,$matches))
				{
					$message = ltrim(explode('/',$matches[1])[0],'"');
				}
				$message = explode(';',$message,2);
				$message = $message[1];
			}

			$row['result'] = $message;
			$ret[] = $row;
		}
		$scanner_history_array = $ret;

		$smarty->assign('scanner_history_array',$scanner_history_array);
	}

	/***************************************************************************************/
	if($tab == 'service')
	{
		$data = Model_EgideScan_TableSort::ts_getListSRV($dbconnection,FALSE,$treeview_type,$treeview_nodeid,$user->getId());
		$data = $data['rows'];

		$services_name =array();
		$services_score=array();
		$services_failles = array();
		foreach($data as $v)
		{
			if( !isset($services_score[$v['srv_name']]))
			{
				$services_score[$v['srv_name']] = $v['avg_score']*$v['vul_total'] ;
				$services_failles[$v['srv_name']] = $v['vul_total'] ;
			}
			else
			{
				$services_score[$v['srv_name']] += $v['avg_score']*$v['vul_total'] ;
				$services_failles[$v['srv_name']] += $v['vul_total'] ;
			}
		}

		foreach($services_score as $key_score => $v_score)
		{
			$services_score[$key_score] = round($services_score[$key_score]/$services_failles[$key_score],2) ;
		}

		arsort($services_failles);
		arsort($services_score);

		$services_failles = array_slice($services_failles, 0, 10);
		$services_score	= array_slice($services_score, 0, 10);

		$services_name_score = array_keys($services_score) ;
		$services_name_failles = array_keys($services_failles) ;

		$services_failles=array_values($services_failles);
		$services_score=array_values($services_score);
		//array_unshift($services_score, 'Services');
		array_unshift($services_failles, 'Services');
		array_unshift($services_score, 'Services');


		$smarty->assign('var_chart_culumn_score',$services_name_score);
		$smarty->assign('var_chart_culumn_faille',$services_name_failles);
		$smarty->assign('var_chart_culumn_y',$services_failles);
		$smarty->assign('var_chart_culumn_y2',$services_score); // corriger la valeur moyenne
	}
	// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%";
}
//Traitement des exceptions SNMP et des erreurs de traitement dans la base de donnée
catch(DeviceNotAliveException $e)
{
	$smarty->assign('errors',array('no'));
}
catch(DeviceSNMPException $e)
{
	$smarty->assign('errors',array($lang['ADM_ERR_SNMP_FAILED']));
}
catch(DeviceException $e)
{
	$smarty->assign('errors',array($e->getMessage()));
}
catch(Exception $e)
{
	$smarty->assign('errors',array($e->getMessage()));
}
}
$smarty->display($path.'/'.$template_path.'control_'.$webp_name.'.html');


function addNavNodeGroups($dbconnection,$nav,$base_url,$nodegroup)
{
	$arr = searchParentNode($dbconnection,$nodegroup);
	//on commence par la fin du tableau afin de ne pas inverser l'ordre
	$i=(count($arr)-1);
	while($i>=0)
	{

		$tmplink = preg_replace('#:id#', $arr[$i]['id'],$base_url);
		$nav->addElement($arr[$i]['name'], $tmplink);
		$i--;
	}
}

function searchParentNode($dbconnection,$nodegroup)
{
	$gr = Model_esia::getParrentGroup($dbconnection,$nodegroup);
	if(!empty($gr))
	{
		$arr[]=array('id'=>$gr[0]['id'],'name'=>$gr[0]['name'] );
		$tmp = searchParentNode($dbconnection,$gr[0]['id']);
		if(isset($tmp))
			$arr = array_merge($arr, $tmp);
			return $arr;
	}
	return null;
}

function getNodeMostCriticalState($arr)
{
	$PRIORITIES_STATES=array("CRITICAL","WARNING","UNKNOWN","OK",'MAINTENANCE','ACQUITTE','PENDING');

	$arr['ok'] = $arr['OK'];
	foreach($PRIORITIES_STATES as $next_pri)
	{
		$next_pri = strtolower($next_pri);
		if( $arr[$next_pri] > 0)
		{
			return $next_pri;
		}
	}
	return 'none';
}
?>
