<?php

$web_path = '/usr/local/esia/public_html/';
$_SERVER['DOCUMENT_ROOT'] = $web_path;

include_once $web_path.'common.php';

include_once $web_path.'esia.conf.php';
include_once $web_path.'Model_esia.php';
include_once $web_path.'plugin/egidescan/model_egidescan.php';

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_EGIDESCAN');
$plugin_url = $arr[0]['apache_path'];
$template_path = $web_path.'plugin/egidescan/templates/' ;

include_once $path.$plugin_url.'/common_egidescan.php';

$type = 'nodes';

try
{
	if( $_REQUEST['type'] == 'nodes')
	{
		$nodes_list = array();

		$treeview_type = $_REQUEST['treeview'];
		$treeview_nodeid = $_REQUEST['nodeid'];
		foreach($_REQUEST as $key => $value)
		{
			$exp = explode('-',$key);
			if( $exp['0'] == 'node' && $exp[1] == 'id' )
			{
				$nodes_list[] = $exp[2];
			}
		}

		$items = array();
		$id_list = array();
		if( !empty($nodes_list) )
		{
			if( $_REQUEST['action'] == 'save' )
			{
				Model_egidescan::acquitVulnerabilitiesFromNodes($dbconnection,$user,$nodes_list);
				$messages[0] = array('message'=>$lang['EGIDE_CONFIRM_ACQ_SAVED']);
				$smarty->assign("ADM_MESSAGE",$messages);
			}

			$nodes_list = Model_egidescan::getNodesByScoring($dbconnection,$user->getId(),$nodes_list);
			foreach($nodes_list as $row)
			{
				$items[]  = array('id'=>$row['id'],'name'=>$row['name'],'nb'=>$row['numberVulnerability']);
				$id_list[] = $row['id'];
			}
		}
	}
	else
	{
		$key0 = 'vul';
		if( $_REQUEST['type'] == 'srv' )
		{
			$key0 = 'srv';
		}
		$vul_list = array();
		$case_list = FALSE;
		if( isset($_REQUEST['case-list']))
		{
			$case_list = json_decode($_REQUEST['case-list'],TRUE);
		}
		if( $case_list == FALSE )
		{
			$case_list = array();
		}

		foreach($case_list as $key => $value)
		{
			$exp = explode('-',$key,3);
			if( $exp['0'] == $key0 && $exp[1] == 'id' && $value == 'true' )
			{
				$vul_list[] = $exp[2];
			}
		}

		$items = array();
		$id_list = array();

		$default = FALSE;
		//$default = (isset($_REQUEST['default']) && $_REQUEST['default'] === 'true' && empty($vul_list));
		if( $_REQUEST['type'] == 'srv' )
		{
			if( !empty($vul_list) || $default )
			{
				if( $_REQUEST['action'] == 'save' )
				{
					Model_egidescan::acquitVulnerabilitiesFromServices($dbconnection,$user,$vul_list,!$default);
					$messages[0] = array('message'=>$lang['EGIDE_CONFIRM_ACQ_SAVED']);
					$smarty->assign("ADM_MESSAGE",$messages);
				}

				$vul_list = Model_egidescan::getServicesByIDList($dbconnection,$user->getId(),$vul_list,!$default);

				foreach($vul_list as $row)
				{
					$items[]  = array('id'=>$row['id'],'name'=>$row['name'],'nb'=>$row['number']);
					$id_list[] = $row['id'];
				}
			}
		}
		elseif( $_REQUEST['type'] == 'vul')
		{
			if(isset($_REQUEST['treeview']))
			{
				$treeview_type = $_REQUEST['treeview'];
				$treeview_nodeid = $_REQUEST['nodeid'];
				$treeview_nodelist = getDevicesOfAgentOrGroup($dbconnection,$user,$treeview_type,$treeview_nodeid);
			}

			if( !empty($vul_list) || $default )
			{
				if( $_REQUEST['action'] == 'save' )
				{
					Model_egidescan::acquitVulnerabilitiesFromNodes($dbconnection,$user,$treeview_nodelist,$vul_list,!$default);
					$messages[0] = array('message'=>$lang['EGIDE_CONFIRM_ACQ_SAVED']);
					$smarty->assign("ADM_MESSAGE",$messages);
				}

				$vul_list = Model_egidescan::getCVEByScoring($dbconnection,$user->getId(),$treeview_nodelist,NULL,$vul_list,!$default);

				foreach($vul_list as $row)
				{
					$items[]  = array('id'=>$row['id'],'name'=>$row['description'],'nb'=>$row['number']);
					$id_list[] = $row['id'];
				}
			}
		}
		elseif( $_REQUEST['type'] == 'acq')
		{
			if( !empty($vul_list) || $default )
			{
				if( $_REQUEST['action'] == 'save' )
				{
					Model_egidescan::unacquitVulnerabilitiesDetect($dbconnection,$vul_list,!$default);
					$messages[0] = array('message'=>$lang['EGIDE_CONFIRM_UNACQ_SAVED']);
					$smarty->assign("ADM_MESSAGE",$messages);
				}

				$vul_list = Model_egidescan::getAcqCVE($dbconnection,$user->getId(),$vul_list,!$default);

				foreach($vul_list as $row)
				{
					$items[]  = array('id'=>$row['id_vul'],'name'=>$row['description'],'device_name'=>$row['device_name'],'service_name'=>$row['service_name']);
					$id_list[] = $row['id'];
				}
			}
			$type = 'acq';
		}
	}
}
catch(Exception $ex)
{
	$smarty->assign('ERRORS',array(array('name'=>get_class($ex),'message'=>$ex->getMessage())));
}
$smarty->assign('type',$type);
$smarty->assign('request_value',$id_list);
$smarty->assign('item_list',$items);
$smarty->display($template_path.'dialog_acquit.html');
?>
