<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
// $webp_name doit être identique au nom de la base de données !!!
$webp_name='WEBP_EGIDESCAN';
//$webp_model='model_'.$webp_name.'.php';
//Inclusion des librairie
include_once $path.'common.php';
include_once $path.'/plugin/egidescan/model_egidescan.php';
//include_once $path.$plugin_url.'/inc/Model_import-module.php';

$webp1 = Model_esia::getWebPlugin($dbconnection);
foreach ($webp1 as $value)
{
	if($value['name'] == 'WEBP_EGIDESCAN')
	{
		$plugin_url = $value['apache_path'];
		$index_page = $value['index_page'];
		break;
	}
}
$smarty->assign('plugin_url',$plugin_url);
$template_path = $plugin_url.'templates/' ;
include_once $path.$plugin_url.'/common_egidescan.php';


$file_scan_date = "/tmp/scan_date.txt";

/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
                    'name'=>$node->getName(),
				    'ip'=>$node->getIPAddress(),
				    'id'=>$node->getId(),
				    'description'=>$node->getDescription(),
				    'group'=>$node->getGroup());
 * SMARTY
        $webp_name nom du plugin
        $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
// include_once $path.'/inc/common_node_control.php';

session_write_close();
try
{
		include_once($path.$plugin_url.'/inc/ParserNmap.php');
		$history_id = $_REQUEST['id'];
		$history_data = Model_egidescan::getScannerHistory($dbconnection,$history_id);
		$history_result = json_decode($history_data['result'],TRUE);
		$nmap_result = parseXmlScan($history_result['result']);

		$format_date = 'Y-m-d H:i:s';
		$header['start'] = date($format_date,$nmap_result['start']);
		$header['end'] = date($format_date,$nmap_result['end']);
		$header['elapsed'] = $nmap_result['elapsed'];
		$header['exit'] = $nmap_result['exit'];
		$header['up'] = $nmap_result['hosts_up'];
		$header['down'] = $nmap_result['hosts_down'];
		$header['total'] = $nmap_result['hosts_total'];

		$hosts_addr = array();
		foreach(explode(',',$history_result['addresses']) as $addr)
		{
			$hosts_addr[$addr] = FALSE;
		}

		$ports_list = array();
		foreach($nmap_result['hosts'] as $host)
		{
				$retRow = array();
				$retRow['start'] = date($format_date,$host['start']);
				$retRow['end'] = date($format_date,$host['end']);
				$retRow['elapsed'] = $host['end'] - $host['start'];
				$retRow['state'] = $host['state'];
				$retRow['reason'] = $host['reason'];

				$mac_list = array();
				$inet_list = array();
				foreach($host['address'] as $addr)
				{
					if($addr['addrtype'] != 'mac')
					{
						if( isset($hosts_addr[$addr['addr']]) )
						{
							$hosts_addr[$addr['addr']] = TRUE;
						}
						$inet_list[]=$addr['addr'];
					}
					else
					{
						$mac_list[]=$addr['addr'];
					}
				}
				$retRow['mac'] = implode(',',$mac_list);
				$retRow['addr'] = implode(',',$inet_list);

				foreach($host['ports'] as $port)
				{
					$retRow['port_id'] = $port['portid'];
					$retRow['port_service'] = $port['service_name'];
					$retRow['port_product'] = $port['service_product'];
					$retRow['port_version'] = $port['service_version'];
					$retRow['vulnerabilities'] = 0;
					foreach($port['scripts'] as $script)
					{
						if( $script['id'] == 'vulscan' )
						{
							$retRow['vulnerabilities'] = count(explode(';',$script['output']));
							break;
						}
					}
					$ports_list[] = $retRow;
				}
		}

		foreach($hosts_addr as $addr => $isUp)
		{
			if( $isUp === FALSE )
			{
				$keys = explode(',','start,end,elapsed,state,reason,mac,addr,port_id,port_service,port_product,port_version,vulnerabilities');
				$retRow = array_fill_keys($keys, '');
				$retRow['state'] = 'down';
				$retRow['addr'] = $addr;
				$retRow['vulnerabilities'] = 0;
				$ports_list[] = $retRow;
			}
		}
		$smarty->assign('header',$header);
		$smarty->assign('ports_list',$ports_list);
}
//Traitement des exceptions SNMP et des erreurs de traitement dans la base de donnée
catch(DeviceNotAliveException $e)
{
	$smarty->assign('errors','no');
}
catch(DeviceSNMPException $e)
{
	$smarty->assign('errors',$lang['ADM_ERR_SNMP_FAILED']);
}
catch(DeviceException $e)
{
	$smarty->assign('errors',$e->getMessage());
}
$smarty->display($path.$template_path.'dialog_history.html');
?>
