<?php
$web_path = '/usr/local/esia/public_html/';
$_SERVER['DOCUMENT_ROOT'] = $web_path;

include_once $web_path.'common.php';

include_once $web_path.'esia.conf.php';
include_once $web_path.'Model_esia.php';

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_EGIDESCAN');
$plugin_url = $arr[0]['apache_path'];
$index_page = $arr[0]['index_page'];
$smarty->assign('plugin_url',$plugin_url);

include_once $web_path.$plugin_url.'/model_egidescan.php';
include_once $web_path.$plugin_url.'/inc/EgideBox.php';

include_once $web_path.'/Model_adm.php';

$template_path = $web_path.$plugin_url.'/templates/' ;

$scan_id = NULL;
$current_scan = NULL;
$view = NULL;

if(isset($_REQUEST['view']))
{
	$view = $_REQUEST['view'];
	$smarty->assign('view',$view);
}

if( isset($_REQUEST['action']))
{
	$action = $_REQUEST['action'];
	$smarty->assign('action',$action);
}

if( isset($_REQUEST['scan_id']))
{
	$scan_id = $_REQUEST['scan_id'];
	$smarty->assign('scan_id',$scan_id);

	try
	{
		$current_scan = model_egidescan::getScanList($dbconnection,$scan_id);
		$current_scan = array_shift($current_scan);
		$selected_scanner = $current_scan['agent_id'];
		$agent_id = $current_scan['agent_id'];
		$smarty->assign('current_conf',$current_scan);
	}
	catch(Exception $ex)
	{
			$ret['name'] = 'UNABLE TO ADD SCAN';
			$ret['message'] = $ex->getMessage();
			$errors[] = $ret;
	}
}
else if(isset($_REQUEST['scanner_node']))
{
	$selected_scanner = $_REQUEST['scanner_node'];
	$agent_id =  $_REQUEST['scanner_node'];
}


if( isset($_REQUEST['save']))
{
	$agent_id = $_REQUEST['scanner_node'];
	$node_group_list = $_REQUEST['nodegroup'];

	$date_start = $_REQUEST['datestart'];
	$time_start = $_REQUEST['hour'];

	$interval_value = $_REQUEST['interval'];
	$interval_unit = $_REQUEST['intervalunity'];

	$retries = $_REQUEST['nb_retries'];
	$retries_interval = $_REQUEST['interval_retries'];
	$retries_interval*=60; //On veut des secondes, pas des minutes

	$ifaces_list = array();
	foreach($_REQUEST as $name => $value)
	{
		$exp = explode('-',$name);
		if($exp[0] == 'iface' && $exp[1] == 'id' && $value == 'on')
		{
			$ifaces_list[] = $exp[2];
		}
	}

	$messages = array();
	foreach($ifaces_list as $iface_id)
	{
		try
		{
			if($action == 'update')
			{
				$scan_id = $_REQUEST['scan_id'];
				$nb_updated = Model_egidescan::updateScan($dbconnection,$scan_id,$date_start,$time_start,$interval_value,$interval_unit,$iface_id,$node_group_list,$retries,$retries_interval);
				if( $nb_updated == 1 )
				{
					$messages[] = array('message'=>$lang['EGIDE_DIALOG_SCAN_UPDATED_MSG']);
				}
				else
				{
					$ret['name'] = 'NOT FOUND';
					$ret['message'] = $lang['EGIDE_DIALOG_SCAN_UPDATE_NOT_FOUND_ERR'];
					$errors[] = $ret;
				}
			}
			else
			{
				Model_egidescan::addScan($dbconnection,$date_start,$time_start,$interval_value,$interval_unit,$iface_id,$node_group_list,$retries,$retries_interval);
				$messages[] = array('message'=>$lang['EGIDE_DIALOG_SCAN_ADDED_MSG']);
			}
		}
		catch(Exception $ex)
		{
				$ret['name'] = 'UNABLE TO ADD SCAN';
				$ret['message'] = $ex->getMessage();
				$errors[] = $ret;
		}

	}
}

if( $view == 'delete')
{
	if( $action == 'delete' && !empty($scan_id))
	{
		try
		{
			Model_egidescan::removeScan($dbconnection,$scan_id);
			$messages[] = array('message'=>$lang['EGIDE_DIALOG_SCAN_DELETED_MSG']);
		}
		catch(Exception $ex)
		{
				$ret['name'] = 'UNABLE TO REMOVE SCAN';
				$ret['message'] = $ex->getMessage();
				$errors[] = $ret;
		}
	}
}
elseif( $view == 'delete_iface')
{
	if( $action == 'delete' && !empty($_REQUEST['iface_id']))
	{
		try
		{
			Model_egidescan::removeIface($dbconnection,$_REQUEST['iface_id']);
			$messages[] = array('message'=>$lang['EGIDE_DIALOG_IFACE_DELETED_MSG']);
		}
		catch(Exception $ex)
		{
				$ret['name'] = 'UNABLE TO REMOVE IFACE';
				$ret['message'] = $ex->getMessage();
				$errors[] = $ret;
		}
	}
}
elseif( $view == 'execute')
{
	if( $action == 'execute' && !empty($scan_id))
	{
		try
		{
			Model_egidescan::startScan($dbconnection,$scan_id);
			$messages[] = array('message'=>$lang['EGIDE_DIALOG_SCAN_EXECUTE_MSG']);
		}
		catch(Exception $ex)
		{
				$ret['name'] = 'UNABLE TO START SCAN';
				$ret['message'] = $ex->getMessage();
				$errors[] = $ret;
		}
	}
}
elseif($view == 'iface_modif')
{
	try
	{
		if( !empty($scan_id))
		{
			$iface_id =  $current_scan['iface_id'];
		}
		else
		{
			$iface_id = $_REQUEST['iface_id'];
		}

		if($action == 'modify')
		{
			model_egidescan::updateEgideIfaceConfiguration($dbconnection,$agent_id,$_REQUEST['box_ifaces_local'],$_REQUEST['box_ifaces_label'],$_REQUEST['box_ifaces_type']);
			$messages[] = array('message'=>$lang['EGIDE_DIALOG_SCAN_IFACE_UPDATED_MSG']);
		}
		$ifacesList = Model_egidescan::getConfiguratedEgideBoxIfaces($dbconnection,$agent_id);
		$db_data_iface = NULL;
		foreach($ifacesList as $row)
		{
			if( $row['id'] == $iface_id)
			{
				$db_data_iface = $row;
				break;
			}
		}

		$ifaces_type = Model_egidescan::getEgideIfacesType($dbconnection);

		$smarty->assign('iface_data',$db_data_iface);
		$smarty->assign('ifaces_type',$ifaces_type);
  }
	catch(Exception $ex)
	{
			$ret['name'] = 'UNABLE TO ADD SCAN';
			$ret['message'] = $ex->getMessage();
			$errors[] = $ret;
	}
}
elseif($view == 'ifaces_mgmt')
{
	try
	{
		if( !empty($scan_id))
		{
			$iface_id =  $current_scan['iface_id'];
		}
		else
		{
			$iface_id = $_REQUEST['iface_id'];
		}

		if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'add' )
		{
			try
			{
				$keys = 'box_ifaces_local,box_ifaces_type,box_ifaces_label';
				$keys = explode(',',$keys);
				$ret = TRUE;
				//Verifie les params
				foreach($keys as $key)
				{
					if( $ret && empty($_REQUEST[$key]) )
					{
						$ret = FALSE;
					}
				}

				if( $ret )
				{
					model_egidescan::addEgideIfaceConfiguration($dbconnection,$agent_id,$_REQUEST['box_ifaces_local'],$_REQUEST['box_ifaces_label'],$_REQUEST['box_ifaces_type']);
					$messages[] = array('message'=>$lang['EGIDE_DIALOG_SCAN_IFACE_ADDED_MSG']);
				}
			}
			catch(Exception $ex)
			{
					$ret['name'] = 'UNABLE TO SET INTERFACE';
					$ret['message'] = $ex->getMessage();
					$errors[] = $ret;
			}
		}

		$ifacesConfiguration = model_egidescan::getConfiguratedEgideBoxIfaces($dbconnection,$agent_id);

		$ifacesConfKeys = array();
		foreach($ifacesConfiguration as $row)
		{
			$ifacesConfKeys[$row['local_name']] = $row;
		}

		$ifacesList = EgideBox::getIfacesList($dbconnection,$agent_id,3,3);
		$notEncodedIfaces = array();
		$interfaces = array();
		foreach($ifacesList as $row)
		{
			$retRow = array();
			$retRow['ifindex'] = $row['ifindex'];
			$retRow['ifname'] = $row['ifname'];
			$retRow['vlan'] = $row['conf']['vlan'];
			$retRow['gesa_label'] = $row['conf']['label'];
			$retRow['flags'] = implode(',',$row['flags']);
			$retRow['mtu'] = $row['mtu'];
			$retRow['operstate'] = $row['operstate'];
			$retRow['type'] = $row['link_type'];
			if( isset($row['conf']['role']) && $row['conf']['role'] == 'mgmt')
			{
				$retRow['type'] = 'MGMT';
			}
			$retRow['mac'] = $row['address'];

			$address['ipv4'] = array();
			$address['ipv6'] = array();
			foreach($row['addr_info'] as $addr)
			{
				if( $addr['family'] == 'inet')
				{
					$address['ipv4'][] = $addr['local'].'/'.$addr['prefixlen'];
				}
				elseif( $addr['family'] == 'inet6')
				{
					$address['ipv6'][] = $addr['local'].'/'.$addr['prefixlen'];
				}
			}
			$retRow['addr'] = implode(',',array_merge($address['ipv4'],$address['ipv6']));
			if( empty($retRow['addr']) && isset(($row['conf']['ip_addr'])))
			{
				$retRow['addr'] = $row['conf']['ip_addr'];
			}
			$retRow['configurable'] = FALSE;
			$retRow['configured'] = FALSE;
			if( $retRow['ifname'] != 'lo' && !empty($retRow['addr']))
			{
				$retRow['configurable'] = TRUE;
				//ifname pour des raisons historiques (en version béta) - gesa_label est préférable (compatibilité VLANs)
				$name_key = NULL;
				if( isset($ifacesConfKeys[$retRow['ifname']]))
				{
					$name_key = 'ifname';
				}
				elseif(isset($ifacesConfKeys[$retRow['gesa_label']]))
				{
					$name_key = 'gesa_label';
				}

				if( $name_key == NULL )
				{
					$notEncodedIfaces[] = $retRow;
				}
				else
				{
					$retRow['configured'] = TRUE;
					$retRow['current_conf'] = $ifacesConfKeys[$retRow[$name_key]];
				}
			}
			$interfaces[] = $retRow;
		}
	}
	catch(Exception $ex)
	{
			$ret['name'] = 'UNABLE TO SHOW DIALOG';
			$ret['message'] = $ex->getMessage();
			$errors[] = $ret;
	}

	$ifaces_type = Model_egidescan::getEgideIfacesType($dbconnection);
	$smarty->assign('selected_scanner',$agent_id);
	$smarty->assign('interfaces',$interfaces);
	$smarty->assign('notEncoded',$notEncodedIfaces);
	$smarty->assign('ifaces_type',$ifaces_type);
}
elseif($view == 'home')
{
	try
	{
		if( isset($current_scan) )
		{
			$state = $current_scan['state'];

			$smarty->assign('current_group_id_list',$current_scan['options']['group_list']);
			$date = explode(' ',$current_scan['next_exec']);

			$time = $date[1];
			$time = explode(':',$time);
			$time = $time[0]*3600 + $time[1]*60 + $time[2];
			$smarty->assign('current_next_time',$time);

			$date = new DateTime($date[0]);
			$smarty->assign('current_next_date',$date->format('d/m/Y'));

			$smarty->assign('interval_value',$current_scan['options']['interval_value']);
			$smarty->assign('interval_unit',$current_scan['options']['interval_unit']);
		}


		$time_scan = explode(':',$_POST['hour']);
		$id_nodes =  $_POST['ip_scanned'] ;
		$date_Sc = $_POST['datestart'] ;
		$hour_Sc = $_POST['hour'] ;
		$scan_date2 = $date_Sc." ".$hour_Sc ;
		$interval_execution = $_POST['interval'] ;
		$intervalunity_execution = $_POST['intervalunity'] ;

		if(!empty($selected_scanner))
		{
			$box_state = Model_esia::countNodeState($dbconnection,$selected_scanner);
			$box_state['info']['gesaId'] = $selected_scanner;
			$box_state['info']['isConnected'] = FALSE;
			$box_state['info']['state'] = $lang['EGIDE_BOX_SHORT'] . ' ';
			if($box_state['critical'] > 0)
			{
				$box_state['info']['state'] .= $lang['EGIDE_BOX_UNREACHEABLE'];
				$box_state['info']['stateClass'] = 'EventCritical';
			}
			elseif($box_state['warning'] > 0)
			{
				$box_state['info']['state'] .= $lang['ALERTS'];
				$box_state['info']['stateClass'] = 'EventWarning';
			}
			elseif($box_state['unknown'] > 0)
			{
				$box_state['info']['state'] .= $lang['EGIDE_BOX_UNREACHEABLE'];
				$box_state['info']['stateClass'] = 'EventUnknown';
			}
			else
			{
				$box_state['info']['state'] .= $lang['EGIDE_BOX_REACHEABLE'];
				$box_state['info']['stateClass'] = 'EventOK';
				$box_state['info']['isConnected'] = TRUE;
			}
			$smarty->assign('box_state', $box_state);
		}

		$nodesList = Model_egidescan::getEgideBoxList($dbconnection, $user->getId());
		$smarty->assign('adm_list_node', $nodesList);
		if( !empty($selected_scanner) )
		{
			$smarty->assign('selected_scanner', $selected_scanner );
			$configurated_ifaces = Model_egidescan::getConfiguratedEgideBoxIfaces($dbconnection,$selected_scanner);
			$interfaces = array();
			if(!empty($configurated_ifaces))
			{
				foreach($configurated_ifaces as $row)
				{
					$retRow = array();
					$retRow['id'] = $row['id'];
					$retRow['label'] = $row['label'];
					$interfaces[] = $retRow;
				}
			}
			$smarty->assign('interfaces',$interfaces);

			//on liste les différents groupes de noeud
			$arr = Model_esia::getGroupDeviceIn($dbconnection);
			$select =array();
			foreach($arr as $top)
			{
				$tmp = convert_tree_to_select($top,0);
				$select = array_merge($select, $tmp);
			}
			$smarty->assign('adm_nodegroup', $select);
		}

		$day_times = array();
		for($i=0;$i < 24; $i++)
		{
			if($i<10)
			{
				$hours='0'.$i;
			}
			else
			{
				$hours=$i;
			}

			$minutes = 0;
			do
			{
				$retRow['secondes'] = $hours*3600+$minutes*60;
				$retRow['human'] = "$hours:".sprintf('%02d', $minutes);
				$day_times[] = $retRow;
				$minutes+=15;
			}
			while ($minutes<60);
		}
		$smarty->assign('day_times',$day_times);
		// echo "%%%%%%%%%%%%%%" ;
		$lastscan_id=Model_egidescan::Lastscan_id($dbconnection) ;

		if(isset($_POST['datestart']) && isset($_POST['hour']))
		{
			$scan_date = str_replace('/','-',$scan_date2) ;
			$date = date_create($scan_date);
			$nextscan_id =$lastscan_id+1 ;
			foreach($id_nodes as $value)
			{
				echo "<pre>";
				print_r($_REQUEST);
				//Model_egidescan::newScan($dbconnection,$nextscan_id,date_format($date, 'Y-m-d H:i:s'),$value,"+$interval_execution $intervalunity_execution",$interface_scan);
				$messages[] = array('message'=>$lang['EGIDE_DIALOG_SCAN_ADDED_MSG']);
				echo "</pre>";
			}

		}
	}
	catch(Exception $ex)
	{
			$ret['name'] = 'UNABLE TO ADD SCAN';
			$ret['message'] = $ex->getMessage();
			$errors[] = $ret;
	}
	$smarty->assign('config',$configurated_ifaces);
}
else
{
	try
	{
		$nodesList = Model_egidescan::getEgideBoxList($dbconnection, $user->getId());
		$smarty->assign('adm_list_node', $nodesList);
		if( !empty($selected_scanner) )
		{
			$box_state = Model_esia::countNodeState($dbconnection,$selected_scanner);

			$smarty->assign('box_state',$box_state);
			$smarty->assign('selected_scanner', $selected_scanner );
		}
	}
	catch(Exception $ex)
	{
			$ret['name'] = 'UNABLE TO ADD SCAN';
			$ret['message'] = $ex->getMessage();
			$errors[] = $ret;
	}
	$smarty->assign('config',$configurated_ifaces);
}

$smarty->assign("ADM_MESSAGE",$messages);
$smarty->assign('ERRORS',$errors);
$smarty->display($template_path.'dialog_scan.html');

function convert_tree_to_select($top,$itt,$parentid=null,$parentname=null)
{
	$pname=null;
	if(isset($parentname))
	{
		$pname = $parentname.' > '.$top['name'];
	}
	else
	{
		$pname = $top['name'];
	}
	$arr=array();
	$arr[]=array('id'=>$top['id'],'name'=>$top['name'],'level'=>$itt,'parent'=>$parentid,'parent_name'=>$pname);
	$itt++;
	if(isset($top['child']))
	{
		$tmp=array();
		foreach($top['child'] as $child)
		{
			$tmp = convert_tree_to_select($child,$itt,$top['id'],$pname);
			$arr = array_merge($arr, $tmp);
		}
	}

	return $arr;
}
?>
