<?php
include_once $path.'/plugin/gesa/model_gesa.php';

class EgideBox
{
    public static function getInstanceEgide($dbconnection,$node_id)
    {
            return Model_gesa::getInstanceGESA($dbconnection,$node_id);
    }

    public static function getIfacesList($dbconnection,$node_id,$timeout,$retries)
    {
        $box = self::getInstanceEgide($dbconnection,$node_id);
        $sn = $box->getSerialNumber();

        $command = 'get_ifaces_list.php';

        for($i=0;$i<$retries;$i++)
        {
            $output = array();
            exec('/usr/local/esia/plugins/check_gesa -G '. $sn . ' -C '. $command. ' -t '.$timeout,$output,$returnexec);
            $decoded = json_decode(implode("\n",$output),TRUE);
            if( is_array($decoded) )
            {
                //On quitte la boucle avec les données
                return $decoded;
            }
        }

        if(empty($output[0]))  throw new GesaConnectionFailed("GESA UNREACHEABLE ".$host,0);
        if(!$accept_unknown && preg_match('#UNKNOWN\s+ERROR#',$output[0]) || $returnexec==3 ) throw new GesaConnectionFailed($output[0],1);
        if(preg_match("#NRPE: Command $command not defined#",$output[0])) throw new GesaConnectionFailed($output[0],2);
        if( !is_array($decoded) )
        {
            throw new GesaConnectionFailed('Unable to decode output json'.$output[0]);
        }
    }
}
