<?php
function parseXmlScan($xml_str)
{
    $parser = simplexml_load_string($xml_str);
    $json = json_encode($parser);
    $decoded = json_decode($json,TRUE);

    $ret = array();
    $ret = getArrayKeys($decoded['@attributes'],'scanner,args,version,xmloutputversion');
    $ret = array_merge($ret,getArrayKeys($decoded['scaninfo']['@attributes'],'type,protocol,numservices,services'));
    $ret = array_merge($ret,getArrayKeys($decoded['@attributes'],'start,startstr'));

    $ret = array_merge($ret,getArrayKeys($decoded['runstats']['finished']['@attributes'],'end:time,endstr:timestr,elapsed,summary,exit'));
    $ret = array_merge($ret,getArrayKeys($decoded['runstats']['hosts']['@attributes'],'up,down,total','hosts_'));

    if( !isset($decoded['host']))
    {
        $decoded['host'] = array();
    }
    elseif( !isset($decoded['host'][0]) )
    {
        $decoded['host'] = array($decoded['host']);
    }

    $ret['hosts'] = array();
    foreach($decoded['host'] as $host)
    {
    $ret_host = array();
    $ret_host = getArrayKeys($host['@attributes'],'start:starttime,end:endtime',NULL);
    $ret_host = array_merge($ret_host,getArrayKeys($host['status']['@attributes'],'state,reason,reason_ttl',NULL));
    $ret_host = array_merge($ret_host,getArrayKeys($host['times']['@attributes'],'srtt,rttvar,to',NULL));

    $retRow = array();
    if( isset($host['os']['osmatch']))
    {
    	if( isset($host['os']['osmatch']['osclass'] ))
    	{
		$host['os']['osmatch'] = array($host['os']['osmatch']);
    	}
    	foreach( $host['os']['osmatch'] as $possible_os)
    	{
                $retClass['name'] = $possible_os['@attributes']['name'];
		$retClass['list'] = array();
		if( isset($possible_os['osclass']['@attributes']))
		{
			$possible_os['osclass'] = array($possible_os['osclass']);
		}
		foreach($possible_os['osclass'] as $osclass)
		{
			$row = getArrayKeys($osclass['@attributes'],'type,vendor,osfamily,osgen,accuracy','os');
			if( empty($osclass['cpe'] ))
			{
				$row['cpe'] = array();
			}
			else
			{
			$row['cpe'] = $osclass['cpe'];
			if( !is_array($row['cpe']))
			{
				$row['cpe'] = array($row['cpe']);
			}
			}
			$retClass['list'][] = $row;
		}
		$retRow[] = $retClass;
    	}
     }
    $ret_host['osmatch'] = $retRow;

    $ret_host['address'] = array();
    if( isset($host['address']['@attributes']))
    {
      $host['address'] = array($host['address']);
    }
    foreach($host['address'] as $addr)
    {
      if( isset($addr['@attributes']))
      {
        $ret_addr = getArrayKeys($addr['@attributes'],'addr,addrtype,vendor',NULL);
        $ret_host['address'][] = $ret_addr;
      }
    }
    $ret_host['ports'] = array();
    if( !isset($host['ports']['port']))
    {
      $host['ports']['port'] = array();
    }
    elseif( !isset($host['ports']['port'][0]))
    {
	$host['ports']['port'] = array($host['ports']['port']);
    }
    foreach($host['ports']['port'] as $port)
    {
      $ret_port = getArrayKeys($port['@attributes'],'portid,protocol',NULL);
      $ret_port = array_merge($ret_port,getArrayKeys($port['state']['@attributes'],'state,reason,reason_ttl',NULL));
      $ret_port = array_merge($ret_port,getArrayKeys($port['service']['@attributes'],'name,product,version,hostname,extrainfo,tunnel,ostype,method,conf,cpe','service_'));
      if(isset($port['service']['cpe'] ))
      {
	  $ret_port['service_cpe'] = $port['service']['cpe'];
      }
      if( empty( $ret_port['service_cpe']))
      {
         $ret_port['service_cpe'] = array();
      }
      elseif( !is_array($ret_port['service_cpe'] ))
      {
	$ret_port['service_cpe'] = array($ret_port['service_cpe']);
      }



      if( isset($port['script']['@attributes']))
      {
        $scripts = array($port['script']);
      }
      elseif( !isset($port['script']) )
      {
        $scripts = array();
      }
      else
      {
        $scripts = $port['script'];
      }
      $ret_port['scripts'] = array();
      foreach($scripts as $script)
      {
        $ret_port['scripts'][] = getArrayKeys($script['@attributes'],'id,output,tunnel,elem',NULL);
      }
      $ret_host['ports'][] = $ret_port;
    }
    $ret['hosts'][] = $ret_host;
  }
  return $ret;
}

function getArrayKeys($arr,$keys,$prefix=NULL)
{
  $keys = explode(',',$keys);
  $ret = array();
  foreach($keys as $key)
  {
    $exp = explode(':',$key);
    $a = $b = $exp[0];
    if( isset($exp[1]) )
    {
      $b = $exp[1];
    }
    if(!empty($prefix))
    {
      $a = $prefix.$a;
    }
    if( !isset($arr[$b]))
    {
      $ret[$a] = NULL;
    }
    else
    {
      $ret[$a] = $arr[$b];
    }
  }
  return $ret;
}
?>
