ALTER TABLE egide_service_access ADD COLUMN max_score real;
ALTER TABLE egide_service_access ADD COLUMN sum_score real;
ALTER TABLE egide_service_access ADD COLUMN total_vul bigint;
ALTER TABLE egide_service_access ADD COLUMN vul_by_node bigint;
ALTER TABLE egide_service_access ADD COLUMN need_refresh boolean;

UPDATE public.egide_provider
SET provider_name='NIST'
WHERE provider_id=1 AND provider_name = 'CVE';

INSERT INTO esia_plugins (plugin_type,plugin_name,plugin_path,plugin_default_parameter,plugin_html_template,plugin_description)
VALUES ('default','CHECK_EGIDE_PONDERATE_SCORE','/usr/local/esia/plugins/check_passive_egide.php','-T ponderate -n $NODENAME -w 3.5 -c 7.5',
	'/usr/local/esia/public_html/theme/plugins/CHECK_WAR_CRI.php',
	'Vérifie le score pondéré des vulnérabilités d''un noeud'
);

INSERT INTO esia_plugins (plugin_type,plugin_name,plugin_path,plugin_default_parameter,plugin_html_template,plugin_description)
VALUES ('default','CHECK_EGIDE_MAX_SCORE','/usr/local/esia/plugins/check_passive_egide.php','-T max -n $NODENAME -w 9.5 -c 10',
	'/usr/local/esia/public_html/theme/plugins/CHECK_WAR_CRI.php',
	'Vérifie le score maximum de la vulnérabilité la plus importante d''un noeud'
);

INSERT INTO rrd_plugins (rrd_plugin_id,rrd_type,rrd_regex,rrd_time,rrd_id,rrd_name,rrd_min,rrd_max,rrd_vertical_label,rrd_graph_type,rrd_graph_color,rrd_regex_threshold,rrd_graph_num,rrd_calc) VALUES ((SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_EGIDE_PONDERATE_SCORE'),'GAUGE','#score_ponderate=([\d\.]+)#',300,DEFAULT,'ponderate',0,10,'score','LINE1','#FFCC00',NULL,NULL,NULL);
INSERT INTO rrd_plugins (rrd_plugin_id,rrd_type,rrd_regex,rrd_time,rrd_id,rrd_name,rrd_min,rrd_max,rrd_vertical_label,rrd_graph_type,rrd_graph_color,rrd_regex_threshold,rrd_graph_num,rrd_calc) VALUES ((SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_EGIDE_MAX_SCORE'),'GAUGE','#score_max=([\d\.]+)#',300,DEFAULT,'max',0,10,'score','LINE1','#FFCC00',NULL,NULL,NULL);
INSERT INTO rrd_plugins (rrd_plugin_id,rrd_type,rrd_regex,rrd_time,rrd_id,rrd_name,rrd_min,rrd_max,rrd_vertical_label,rrd_graph_type,rrd_graph_color,rrd_regex_threshold,rrd_graph_num,rrd_calc) VALUES ((SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_EGIDE_MAX_SCORE'),'GAUGE','#total_vul=(\d+)#',300,DEFAULT,'match',0,-1,'nb','AREA','#FFCC00',NULL,1,NULL);

INSERT INTO esia_service_patterns (pattern_id,pattern_name,pattern_description) VALUES (DEFAULT,'default_scan_egide','Pattern pour un noeud scanné avec egidescan');

INSERT INTO esia_service_pattern_included (included_id,included_name,included_pattern_id,included_plugin_id,included_parameter,included_interval,included_program_id,included_program_parameter,included_unknown,included_warning,included_critical,included_priority) VALUES (DEFAULT,'CHECK_EGIDE_PONDERATE_SCORE',(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_scan_egide'),(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_EGIDE_PONDERATE_SCORE'),(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_EGIDE_PONDERATE_SCORE'),300000,NULL,NULL,NULL,NULL,NULL,7);

INSERT INTO esia_service_pattern_included (included_id,included_name,included_pattern_id,included_plugin_id,included_parameter,included_interval,included_program_id,included_program_parameter,included_unknown,included_warning,included_critical,included_priority) VALUES (DEFAULT,'CHECK_EGIDE_MAX_SCORE',(SELECT pattern_id FROM esia_service_patterns WHERE pattern_name='default_scan_egide'),(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_EGIDE_MAX_SCORE'),(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_EGIDE_MAX_SCORE'),300000,NULL,NULL,NULL,NULL,NULL,7);


INSERT INTO esia_plugins (plugin_type,plugin_name,plugin_path,plugin_default_parameter,plugin_default_interval_time,plugin_cron_type,plugin_cron_only_existing)
VALUES ('cron','CRON_EGIDE_SCAN_PLUGINS','/usr/local/esia/public_html/plugin/egidescan/cron/passive_egide_node_plugin.php','',60000,'minute',TRUE);

INSERT INTO esia_cron_plugin (
    cron_plugin_id,
    cron_interval,
    cron_status,
    cron_next_exec,
    cron_log_file,
    cron_retries,
    cron_parameter
)
VALUES (
    (SELECT plugin_id FROM esia_plugins WHERE plugin_name = 'CRON_EGIDE_SCAN_PLUGINS'),
    '1 minute'::interval,
    'PENDING',
    NOW() + interval '1 minute',
    'cron_egide_scan_plugins_$SERVICEID_$DATE.log',
    0,
    ''
);
