--NAME:CHECK_DB_CVE_SYNC
--INFRA:CHECK

INSERT INTO esia_plugins (plugin_id,plugin_name,plugin_path,plugin_type,plugin_trap_oid,plugin_default_parameter,plugin_default_interval_time,plugin_description,plugin_delete,plugin_priority,plugin_html_template,plugin_manufacturer,plugin_tag,plugin_cron_type,plugin_cron_only_existing) VALUES (DEFAULT,'CHECK_DB_CVE_SYNC','/usr/local/esia/plugins/check_egide_db_sync.php','default',NULL,'-w 1 -c 2',900000,'Test si la synchronisation des CVEs s''effectue correctement.
Vérifie 2 choses :
- La date de mise à jour de la dernière CVE
- La date de création du dernier package de CVEs
','false',7,NULL,'Esia','EGIDE,CVE,SYNC',NULL,NULL);

INSERT INTO esia_services(
	service_plugin_id,
	service_device_id,
	service_interval_time,
	service_parameter,
	service_id,
	service_name,
	service_delete,
	service_priority)
VALUES(
	(SELECT plugin_id FROM esia_plugins WHERE plugin_name='CHECK_DB_CVE_SYNC'),
	(SELECT MIN(device_id) FROM esia_device where device_ip_address = '127.0.0.1'),
	(SELECT plugin_default_interval_time FROM esia_plugins WHERE plugin_name='CHECK_DB_CVE_SYNC'),
	(SELECT plugin_default_parameter FROM esia_plugins WHERE plugin_name='CHECK_DB_CVE_SYNC'),
	DEFAULT,
	(SELECT plugin_name FROM esia_plugins WHERE plugin_name='CHECK_DB_CVE_SYNC'),
	false,
	7
);

ALTER table egide_services ALTER COLUMN eg_service_version TYPE character varying(50);

-- Cron import KB CVE list
INSERT INTO esia_plugins(
    plugin_id, plugin_name, plugin_path, plugin_type, plugin_default_interval_time, plugin_description, plugin_priority, plugin_manufacturer, plugin_tag, plugin_cron_type, plugin_cron_only_existing
) VALUES (
    DEFAULT, 'CRON_EGIDE_IMPORT_KB_PROPS', '/usr/local/esia/public_html/plugin/egidescan/cron/egide_import_kb_properties.php', 'cron', 86400000, 'Importation de la liste des CVE acquittes par les KB', 5, 'ESIA', 'ESIA,EGIDE,CRON', 'day', true
);

INSERT INTO esia_cron_plugin(
	cron_id, cron_plugin_id, cron_interval, cron_next_exec, cron_log_file, cron_retries, cron_retries_interval
) VALUES (
    DEFAULT, (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CRON_EGIDE_IMPORT_KB_PROPS'), '1 day'::interval, CURRENT_DATE + interval'25 hour', 'egide_kb_import_$SERVICEID_$DATE.log', 1, '30 minute'::interval
);

CREATE TABLE IF NOT EXISTS public.egide_vulnerability_detect_state
(
    state_id serial,
    state_name character varying(10) NOT NULL,
    PRIMARY KEY (state_id)
);
ALTER TABLE IF EXISTS public.egide_vulnerability_detect_state OWNER to esia;

ALTER TABLE IF EXISTS public.egide_vulnerability_detect  ADD COLUMN detect_state_id integer;

ALTER TABLE IF EXISTS public.egide_vulnerability_detect
    ADD CONSTRAINT "detect_foreignKey_state" FOREIGN KEY (detect_state_id)
    REFERENCES public.egide_vulnerability_detect_state (state_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION
    NOT VALID;
CREATE INDEX IF NOT EXISTS "fki_detect_foreignKey_state" ON public.egide_vulnerability_detect(detect_state_id);
INSERT INTO public.egide_vulnerability_detect_state(state_id, state_name)VALUES (DEFAULT,'ACTIVE');
INSERT INTO public.egide_vulnerability_detect_state(state_id, state_name)VALUES (DEFAULT,'CLOSED');
INSERT INTO public.egide_vulnerability_detect_state(state_id, state_name)VALUES (DEFAULT,'ACQUIT');
UPDATE egide_vulnerability_detect SET detect_state_id=(SELECT state_id FROM egide_vulnerability_detect_state WHERE state_name=detect_state);
